using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;

namespace FitchnealServer
{
    public partial class GetPlayers : Form
    {
        private int whichMode = 0;      // 0 = Network vs. Human,  1 = Human vs. Network, 2 = network vs. Network
        private Fitchneal controller = null;

        public GetPlayers()
        {
            InitializeComponent();
        }

        public GetPlayers(int option, Fitchneal caller)
        {
            whichMode = option;
            this.controller = caller;
            InitializeComponent();
        }

        private String getIP()
        {
            string strHostName = "";
            // Getting Ip address of local machine...
            // First get the host name of local machine.
            strHostName = System.Net.Dns.GetHostName();
            string IP = "";
            //Console.WriteLine("Local Machine's Host Name: " + strHostName);            

            // Then using host name, get the IP address list..
            IPHostEntry ipEntry = System.Net.Dns.GetHostEntry(strHostName);
            IPAddress[] addr = ipEntry.AddressList;

            for (int i = 0; i < addr.Length; i++)
            {
                IP = IP + addr[i].ToString() + "    ";
                //Console.WriteLine("IP Address {0}: {1} ", i, addr[i].ToString());
            }
            return IP;
        }

        private void GetPlayers_Load(object sender, EventArgs e)
        {
        }

        private void GetPlayers_Shown(object sender, EventArgs e)
        {
            lblIPAddress.Text = "My IP Address(es): " + getIP();
            byte[] data = new byte[1024];

            // Network player for attacker
            if ((whichMode == 0) || (whichMode == 2))
            {
                lblWaiting.Text = "Waiting for the attacker to connect to port 8112.";
                Application.DoEvents();
                controller.sockAttacker = controller.mainSocket.Accept();
                string welcome = "attacker\r\n";
                data = Encoding.ASCII.GetBytes(welcome);
                controller.sockAttacker.Send(data, data.Length, SocketFlags.None);
                lblWaiting.Text = "Connection established with attacking player.";
            }

            // Network player for defender
            if ((whichMode == 1) || (whichMode == 2))
            {
                lblWaiting2.Text = "Waiting for the defender to connect to port 8112.";
                Application.DoEvents();
                controller.sockDefender = controller.mainSocket.Accept();
                string welcome = "defender\r\n";
                data = Encoding.ASCII.GetBytes(welcome);
                controller.sockDefender.Send(data, data.Length, SocketFlags.None);
            } 
            this.Close();
        }
    }
}